# list in format z:n/n[.p] bytes
set list_of_nodes [list]
set list_of_bytes [list]

proc countbytes { filename } {
# puts stdout "Counting bytes is $filename"
 set handle [open $filename "r"]
 set totalbytes 0
 if {$handle != -1} {
 # puts stdout "Opened file\n"
  while {[gets $handle currentline] != -1} {
   if {[string index $currentline 0] == "#"} {
    set currentline [string range $currentline 1 255]
   }
   if {[string index $currentline 0] == "^"} {
    set currentline [string range $currentline 1 255]
   }
#   puts stdout "corrected line is $currentline"
   if [file exists $currentline] {
    set totalbytes [expr $totalbytes + [file size $currentline]]
   }
  }
  close $handle
 } else {
  puts stderr "Cannot open $filename"
 }
# puts stdout "$totalbytes in .clo"
 return $totalbytes
}


proc count_directory {outbound nodde nett} {
# nodde and nett is used when counting point directories; for
# main outbound it must be 0 0 
 global  zone list_of_nodes list_of_bytes

 set hlos [glob -nocomplain $outbound ]
 foreach i $hlos {
#  puts stdout "Parcing $i"
#  puts stdout [expr [string length $i] - 11]
  set splitted_filename [split $i /]
  set filename [lindex $splitted_filename [expr [llength $splitted_filename] -1 ] ]
#  puts stdout "$filename"
  if {[string length $filename] == 12} {
    if [expr $nodde + $nett] {
     set full_node "$zone:$nett/$nodde.[expr 0x[string range $filename 4 7]]"
    } else {
#	we're looking in main outbound
     set net [expr 0x[string range $filename 0 3]]
     set node [expr 0x[string range $filename 4 7]]
     set full_node "$zone:$net/$node"
    }
#  cheking if we have worked with this node but with other flavour
   set indexx [lsearch -exact $list_of_nodes $full_node ]
   if {-1 == $indexx} {
#   no, we havent
    set list_of_nodes [lappend list_of_nodes $full_node]
    set list_of_bytes [lappend list_of_bytes [countbytes $i]]
#    puts stdout "$full_node addind into list"
   } else {
#    yes, we did
#    puts stdout "$full_node allready in list"
    set new_bytes_for_that_node [ expr [lindex $list_of_bytes $indexx] + [countbytes $i] ]
    set list_of_bytes [ lreplace $list_of_bytes $indexx $indexx $new_bytes_for_that_node]
   }
  } else {
   puts stderr "Strange .clo $filename"
  }
# set f [open $i "r"]
 }
}
################################# Main procedure #############################
puts stderr "Calculator of outbound statistic for BSO by Dmitry the Zuryanovich"
puts stderr "TclOutB 0.00.01 Aug 1998"

if  {[llength $argv] != 2} {
 puts stderr "Arguments should be: path_to_outbound zone_for_this_outbound"
 puts stderr "example: tclsh tcloutb c:/usr/fido/out 2\nNote: outbound must have FORWARD slashes"
 exit
}
set outbound [lindex $argv 0]
set zone [lindex $argv 1]

set currd [format "%s/*.?lo" $outbound]
#puts stdout "$currd"
count_directory $currd 0 0

set currd [format "%s/*.pnt" $outbound]
#puts stdout "$currd"
set pntdirs [glob -nocomplain $currd]
foreach i $pntdirs {
# puts stdout "looking for points in $i"
 set currd [format "%s/*.?lo" $i]
 
 set splitted_filename [split $i /]
 set filename [lindex $splitted_filename [expr [llength $splitted_filename] -1 ] ]
 set node [expr 0x[string range $filename 0 3]]
 set net [expr 0x[string range $filename 4 7]]

 count_directory $currd $net $node
}


#foreach i $list_of_nodes {
# puts stdout "In list $i"
#}
#foreach i $list_of_bytes {
# puts stdout "In list $i"
#}

puts stdout "OutBound statistics for zone $zone\n"
#### Sorting
while [llength $list_of_nodes] {
 set indexx 0
 set indexx_of_max 0
 set maximum 0
 foreach i $list_of_bytes {
  if {$maximum < $i} {
   set maximum $i
   set indexx_of_max $indexx
  }
  set indexx [expr 1+$indexx]
 }
 puts stdout "[lindex $list_of_nodes $indexx_of_max]\t\t$maximum"

 if {[llength $list_of_nodes] == 1} {
  break
 }
 set list_of_nodes [lreplace $list_of_nodes $indexx_of_max $indexx_of_max]
 set list_of_bytes [lreplace $list_of_bytes $indexx_of_max $indexx_of_max]
# puts stdout "List of nodes became"
# foreach i $list_of_nodes {
#  puts -nonewline stdout " $i"
# }
# puts stdout "\nList of bytes became"
# foreach i $list_of_bytes {
#  puts -nonewline stdout " $i"
# }
}
puts stdout "\nStatistics created by TclOutbound 0.00.01 on TCL $tcl_version running at $tcl_platform(os) $tcl_platform(osVersion) "
